Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.stat.descriptive.moment
Class ThirdMoment

    java.lang.Object
      org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
          org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
              org.apache.commons.math.stat.descriptive.moment.FirstMoment
                  org.apache.commons.math.stat.descriptive.moment.SecondMoment
                      org.apache.commons.math.stat.descriptive.moment.ThirdMoment

All Implemented Interfaces:
  Serializable, StorelessUnivariateStatistic, UnivariateStatistic

Direct Known Subclasses:
  FourthMoment

public class ThirdMoment
extends SecondMoment
implements Serializable

Computes a statistic related to the Third Central Moment. Specifically, what is computed is the sum of cubed deviations from the sample mean.

The following recursive updating formula is used:

Let

- dev = (current obs - previous mean)
- m2 = previous value of `SecondMoment`
- n = number of observations (including current obs)

Then

new value = old value - 3 * (dev/n) * m2 + (n-1) * (n -2) * (dev^3/n^2)

Returns `Double.NaN` if no data values have been added and returns `0` if there is just one value in the data set.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Revision: 1.1 $ $Date: 2004/10/08 05:08:17 $
See Also:
  Serialized Form

Field Summary
`protected double` | `m3` third moment of values that have been added
`protected double` | `nDevSq` Square of deviation of most recently added value from previous first moment, normalized by previous sample size.
`(package private) static long` | `serialVersionUID` Serializable version identifier

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`m2`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`dev, m1, n, nDev`

Constructor Summary
`ThirdMoment()` Create a FourthMoment instance

Method Summary
`void` | `clear()` Clears the internal state of the Statistic
`double` | `getResult()` Returns the current value of the Statistic.
`void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`getN`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
`equals, evaluate, evaluate, hashCode, incrementAll, incrementAll`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
`test`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### m3

    protected double m3

  third moment of values that have been added

### nDevSq

    protected double nDevSq

  Square of deviation of most recently added value from previous first moment, normalized by previous sample size. Retained to prevent repeated computation in higher order moments. nDevSq = nDev * nDev.

Constructor Detail

### ThirdMoment

    public ThirdMoment()

  Create a FourthMoment instance

Method Detail

### increment

    public void increment(double d)

  Description copied from interface: `StorelessUnivariateStatistic`
  Updates the internal state of the statistic to reflect the addition of the new value.

  Specified by:
    `increment` in interface `StorelessUnivariateStatistic`
  Overrides:
    `increment` in class `SecondMoment`
  See Also:
    `StorelessUnivariateStatistic.increment(double)`

### getResult

    public double getResult()

  Description copied from interface: `StorelessUnivariateStatistic`
  Returns the current value of the Statistic.

  Specified by:
    `getResult` in interface `StorelessUnivariateStatistic`
  Overrides:
    `getResult` in class `SecondMoment`
  See Also:
    `StorelessUnivariateStatistic.getResult()`

### clear

    public void clear()

  Description copied from interface: `StorelessUnivariateStatistic`
  Clears the internal state of the Statistic

  Specified by:
    `clear` in interface `StorelessUnivariateStatistic`
  Overrides:
    `clear` in class `SecondMoment`
  See Also:
    `StorelessUnivariateStatistic.clear()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2004 The Apache Software Foundation. All Rights Reserved.